<?php

/****************************************************/
/* MiniGriSpip 1.4.2 - 2007 (c) FredoMkb */
/* Fonctions pour le calendrier du squelette "MiniGriSpip" */
/****************************************************/

function asciihtml($textHtml) {
// Fonction pour retourner le texte Html fourni ($textHtml) converti en codes Ascii Html ($asciiHtml).
// Exemple d'utilisation : [(#TEXT|asciihtml)]
// Petite adaptation d'un code issu d'une contribution sur Spip'Contrib proposee par Jean Luc Girard et Coyote, merci a eux.
// Voir : <http://www.spip-contrib.net/Crypter-une-adresse-email>

        $asciiHtml = '';
        for ($i = 0; $i < strlen($textHtml); $i++) {
          $asciiHtml .= '&#'.ord($textHtml[$i]).';';
        }
      return $asciiHtml;
}

function fileofurl($theUrl) {
// Fonction pour retourner le nom du document pointe par une adresse Url.
	$docNomList = explode("/", $theUrl);
	$docNom = $docNomList[sizeof($docNomList)-1];
	return $docNom;
}


function nombre_publications_date($dateStart,$dateEnd) {
// Fonction pour retourner le nombre d'articles, de breves et commentaires publies existants dans une date donnee ($date)
	
	global $table_prefix; // Pour pouvoir utiliser des prefixes personnalises autres que "spip"
	$requete = mysql_query("SELECT * FROM ".$table_prefix."_articles WHERE date>='$dateStart' AND date<'$dateEnd' AND statut='publie'");
	$nbr_articles = mysql_num_rows($requete);
	$requete = mysql_query("SELECT * FROM ".$table_prefix."_breves WHERE date_heure>='$dateStart' AND date_heure<'$dateEnd' AND statut='publie'");
	$nbr_breves = mysql_num_rows($requete);
	$requete = mysql_query("SELECT * FROM ".$table_prefix."_forum WHERE date_heure>='$dateStart' AND date_heure<'$dateEnd' AND statut='publie'");
	$nbr_forums = mysql_num_rows($requete);
	mysql_free_result($requete);
	
	$total = $nbr_articles + $nbr_breves + $nbr_forums;
	$resultat = '';
	if ($total > 0) {
		$resultat = $resultat.' title=" - Articles publies : '.$nbr_articles." \n".' - Breves publiees : '.$nbr_breves." \n".' - Commentaires publies : '.$nbr_forums.' "';
	}
	return $resultat;
}

function cal_site($theDate=null, $calTout=null, $calLang=null, $calPage=null, $calJour=null, $calMois=null) {
// Fonction pour generer un calendrier indiquant les articles, breves et commentaires publies

	// Si la date n'est pas fournie, alors on prend la date actuelle
	if (!isset($theDate)) { $theDate = date('Y-m-d'); }
	// Si une date est presente dans l'adresse Url, alors on prend celle-ci
	$laDate = $_GET['date'];
	if (isset($laDate)) { $theDate = $laDate; }

	// Si la localisation n'est pas fournie, alors on regle le francais par defaut
	if (!isset($calTout)) { $calTout = true; }

	// Si la localisation n'est pas fournie, alors on regle le francais par defaut
	if (!isset($calLang)) { $calLang = array('fr_FR.UTF-8', 'fr', 'fr_FR'); }
	// On regle la localisation selon la valeur obtenue
	setlocale (LC_TIME, $calLang);

	// On defini les pages Html de construction des liens
	if (!isset($calPage)) { $calPage = 'calendrier'; }
	if (!isset($calJour)) { $calJour = 'inc-cal-jour'; }
	if (!isset($calMois)) { $calMois = 'inc-cal-mois'; }

	// On separe les differents elements de la date fournie
	$day = date('j', strtotime($theDate));
	$month = date('n', strtotime($theDate));
	$year = date('Y', strtotime($theDate));
	
	// On verifie la validite de la date avant de generer le calendrier
	// <http://www.php.net/manual/fr/function.setlocale.php>
	// Codes des langues : <http://www.w3.org/WAI/ER/IG/ert/iso639.htm>
	if (checkdate($month, 1, $year)) {
   		
		// Date actuelle
		$now = date('Y-m-d');
		$nowDay = date('j', strtotime($now));
		$nowMonth = date('n', strtotime($now));
		$nowYear = date('Y', strtotime($now));
		
		// Nettoyage de l'adresse Url pour construir les liens
		$requete = $_SERVER['argv'][0];
		$debut = '?'.$requete.'&';
		$debut = preg_replace('#var_mode=.*?([\&])#i','',$debut);
		$debut = preg_replace('#date=.*?([\&])#i','',$debut);
		$debut = rtrim($debut, '&');
		$debut = str_replace('?&','?',$debut);
		$debut = str_replace('&&','&',$debut);
		
		// On remplace l'affichage jour par l'affichage mois, et vise-versa
		$debutMois = str_replace($calJour,$calMois,$debut);
		$debutJour = str_replace($calMois,$calJour,$debut);

		// On defini les differentes dates a utiliser
		// <http://www.php.net/manual/fr/function.mktime.php>
		$dateNow = mktime(0, 0, 0, $nowMonth, $nowDay, $nowYear);
		$dateLien = mktime(0, 0, 0, $month, $day, $year);
		$dateLienJour1 = mktime(0, 0, 0, $month, 1, $year);
		$dateLienJourPlus1 = mktime(0, 0, 0, $month, $day + 1, $year);
		$dateLienJourMoins1 = mktime(0, 0, 0, $month, $day - 1, $year);
		$dateLienMoisPlus1 = mktime(0, 0, 0, $month + 1, 1, $year);
		$dateLienMoisMoins1 = mktime(0, 0, 0, $month - 1, 1, $year);
		
		// On definie le 'lundi' comme premier jour de la semaine et le 'dimanche' comme le dernier
		if (!$day = date("w", $dateLienJour1)) $day = 7; 
       	
		// Le Calendrier
		$cal = "";
		
		// Recuperation du nombre d'articles, breves et commentaires publies pendant le mois considere
		$dateMois = strftime("%Y-%m-%d", $dateLienJour1);
		$dateMoisPlus1 = strftime("%Y-%m-%d", $dateLienMoisPlus1);
		$titreMois = nombre_publications_date($dateMois, $dateMoisPlus1);
		
		// Si c'est un calendrier entier on genere les liens vers les mois precedent et suivant
		if ($calTout) {
		// Construction des liens des mois precedent, actuel et suivant
			$lienMoisMoins = '<a href="'.$debutMois.'&date='.strftime("%Y-%m-%d", $dateLienMoisMoins1).'" title="'.strftime("%B %Y", $dateLienMoisMoins1).'">&laquo;</a>';
			$lienMoisLien = '<a href="?page='. $calPage.'&cal='.$calMois.'&date='.strftime("%Y-%m-%d", $dateLienJour1).'"'.$titreMois.'>'.strftime("%B %Y", $dateLien).'</a>';
			$lienMoisPlus = '<a href="'.$debutMois.'&date='.strftime("%Y-%m-%d", $dateLienMoisPlus1).'" title="'.strftime("%B %Y", $dateLienMoisPlus1).'">&raquo;</a>';
			
			// On affiche le nom entier du mois considere suivant la localisation, et les liens vers les mois precedent et suivant
			// <http://www.php.net/manual/fr/function.strftime.php>
			$cal = $cal.'<table border=0><tr class="cal_titre"><th>'.$lienMoisMoins.'</th><th colspan=5>'.$lienMoisLien.'</th><th>'.$lienMoisPlus.'</th></tr><tr>';
		} else {
		// Construction des liens du mois actuel 
			$lienMoisLien = '<a href="?page='. $calPage.'&cal='.$calMois.'&date='.strftime("%Y-%m-%d", $dateLienJour1).'"'.$titreMois.'>'.strftime("%B %Y", $dateLien).'</a>';
			// On affiche le nom entier du mois considere suivant la localisation, et les liens vers les mois precedent et suivant
			// <http://www.php.net/manual/fr/function.strftime.php>
			$cal = $cal.'<table border=0><tr class="cal_titre"><th colspan=7>'.$lienMoisLien.'</th></tr><tr>';
		}
       
		// On affiche les abreviations des jours de la semaine suivant la localisation (Lun, Mar, Mer, Jeu, Ven, Sam, Dim)
		for ($i = 8; --$i;) {
			$cal = $cal.'<th>'. strftime("%a", mktime(0, 0, 0, $month, 16 - $i - $day, $year)).'</th>'; 
		}
           
		// On affiche les eventuelles cellules vides au debut du mois
		$cal = $cal.'</tr><tr>'.str_repeat('<td></td>', --$day); 
       
		// On genere les differents jours du calendrier du mois
		// <http://www.php.net/manual/fr/function.checkdate.php>
		while (checkdate($month, ++$i, $year)) { // $i==0 after for :-)
			// Recuperation du nombre d'articles, breves et commentaires publies pendant le jour considere
			$dateJour = strftime("%Y-%m-%d", mktime(0, 0, 0, $month, $i, $year));
			$dateJourPlus1 = strftime("%Y-%m-%d", mktime(0, 0, 0, $month, $i + 1, $year));
			$titreJour = nombre_publications_date($dateJour,$dateJourPlus1);
			
			// Pour le style de la cellule du calendrier contenant la date actuelle
			if ($dateJour == $now) { $sel = ' class="cal_sel"'; } else { $sel = ""; };
			
			// S'il y a des publications alors on construit le lien
			if ($titreJour == '') {
				$cal = $cal.'<td'.$sel.'>'.$i.'</td>';
			} else {
				$cal = $cal.'<td'.$sel.'><a href="?page='.$calPage.'&cal='.$calJour.'&date='.$dateJour.'"'.$titreJour.'>'.$i.'</a></td>';
			}
			
			// Nouvelle rangee du tableau au bout de 7 jours
			if (!(++$day % 7)) $cal = $cal.'</tr><tr>'; 
	
	}
		// Fin du tableau calendrier
		$cal = $cal.'</tr></table>';

		// Si c'est un calendrier entier on genere le lien vers la date actuelle
		if ($calTout) {
			// Lien de la date actuelle
			$cal = $cal.'<p class="cal_now"><a href="'.$debutJour.'&date='.strftime("%Y-%m-%d",$dateNow).'">'.strftime("Aujourd'hui %A %e %B %Y",$dateNow).'</a></p>';
		} else {
			$cal = $cal.'<p style="border-bottom: 1px solid #cccccc;"></p>';
		}
		
		// Retour du calendrier
		return $cal;
	} 
} 

?>