<?php

/****************************************************/
/* MiniGriSpip 1.4.2 - 2007 (c) FredoMkb */
/* Fonctions pour les infos du squelette "MiniGriSpip" */
/****************************************************/

function visites_site($day) {
// Fonction pour afficher le nombre de visites enregistrees sur le site.
// Le parametre "today" retourne les visites du jour courant.
// Le parametre "all" retourne le total des visites depuis l'ouverture du site.
// Ce code est librement inspire du squelette Sarka-Spip <http://sarka-spip.com/>

	global $table_prefix; // Pour pouvoir utiliser des prefixes personnalises autres que "spip"
	$r = 0;
	if ( $day == 'today' ) {
		$today = date('Y-m-d',strtotime(date('Y-m-d')));
		$query = "SELECT visites AS visites FROM ".$table_prefix."_visites WHERE date='$today'";
		$result = spip_query($query);
		$visit_today = 0;
		if ($row = @spip_fetch_array($result)) {
			$visit_today = $row['visites'];
		}
		$r = $visit_today;
	}
	else if ( $day == 'all' ) {
		$query = "SELECT SUM(visites) AS total_absolu FROM ".$table_prefix."_visites";
		$result = spip_query($query);
		$visit_all = 0;
		if ($row = @spip_fetch_array($result)) {
			$visit_all = $row['total_absolu'];
		}
		$r = $visit_all;
	}
	return $r;
}

?>